Subject: bug#7872: Possible fix for relative pathnames given through the command line

From: Roy Liu <[email-masked]>
Date: Wed, 19 Jan 2011 21:48:56 -0500

I've noticed that Emacs.app opens up relative pathnames twice -- once for
the actual file, and once for the relative pathname appended to the
directory of the current buffer.
For example, trying to open by "a/b/text.txt" opens "a/b/text.txt" and
attempts to open "a/b/a/b/text.txt".

I wonder if the following patch corrects the problem:

--- lisp/term/ns-win.el.orig    2010-12-12 23:31:04.000000000 -0500
+++ lisp/term/ns-win.el 2010-12-12 23:32:00.000000000 -0500
@@ -785,7 +785,7 @@
   "Do a `find-file' with the `ns-input-file' as argument."
   (interactive)
   (let ((f) (file) (bufwin1) (bufwin2))
-    (setq f (file-truename (car ns-input-file)))
+    (setq f (file-truename (expand-file-name (car ns-input-file)
command-line-default-directory)))
     (setq ns-input-file (cdr ns-input-file))
     (setq file (find-file-noselect f))
     (setq bufwin1 (get-buffer-window file 'visible))

Here, the input filename is expanded according to the current working
directory when Emacs was invoked.  Since I'm no expert, I don't know if this
breaks something else.

Thanks for your time!